// Code generated by entc, DO NOT EDIT.

package adapter

const (
	// Label holds the string label denoting the adapter type in the database.
	Label = "adapter"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldName holds the string denoting the name field in the database.
	FieldName = "name"
	// FieldTag holds the string denoting the tag field in the database.
	FieldTag = "tag"
	// FieldModule holds the string denoting the module field in the database.
	FieldModule = "module"
	// EdgeOwner holds the string denoting the owner edge name in mutations.
	EdgeOwner = "owner"
	// Table holds the table name of the adapter in the database.
	Table = "adapter"
	// OwnerTable is the table that holds the owner relation/edge.
	OwnerTable = "adapter"
	// OwnerInverseTable is the table name for the Organization entity.
	// It exists in this package in order to avoid circular dependency with the "organization" package.
	OwnerInverseTable = "organization"
	// OwnerColumn is the table column denoting the owner relation/edge.
	OwnerColumn = "adapter_owner"
)

// Columns holds all SQL columns for adapter fields.
var Columns = []string{
	FieldID,
	FieldName,
	FieldTag,
	FieldModule,
}

// ForeignKeys holds the SQL foreign-keys that are owned by the "adapter"
// table and are not defined as standalone fields in the schema.
var ForeignKeys = []string{
	"adapter_owner",
}

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	for i := range ForeignKeys {
		if column == ForeignKeys[i] {
			return true
		}
	}
	return false
}

var (
	// NameValidator is a validator for the "name" field. It is called by the builders before save.
	NameValidator func(string) error
	// TagValidator is a validator for the "tag" field. It is called by the builders before save.
	TagValidator func(string) error
	// ModuleValidator is a validator for the "module" field. It is called by the builders before save.
	ModuleValidator func(string) error
)
