// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/licenseuse"
	"github.com/valocode/bubbly/ent/predicate"
)

// LicenseUseDelete is the builder for deleting a LicenseUse entity.
type LicenseUseDelete struct {
	config
	hooks    []Hook
	mutation *LicenseUseMutation
}

// Where appends a list predicates to the LicenseUseDelete builder.
func (lud *LicenseUseDelete) Where(ps ...predicate.LicenseUse) *LicenseUseDelete {
	lud.mutation.Where(ps...)
	return lud
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (lud *LicenseUseDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(lud.hooks) == 0 {
		affected, err = lud.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*LicenseUseMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			lud.mutation = mutation
			affected, err = lud.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(lud.hooks) - 1; i >= 0; i-- {
			if lud.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = lud.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, lud.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (lud *LicenseUseDelete) ExecX(ctx context.Context) int {
	n, err := lud.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (lud *LicenseUseDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: licenseuse.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: licenseuse.FieldID,
			},
		},
	}
	if ps := lud.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return sqlgraph.DeleteNodes(ctx, lud.driver, _spec)
}

// LicenseUseDeleteOne is the builder for deleting a single LicenseUse entity.
type LicenseUseDeleteOne struct {
	lud *LicenseUseDelete
}

// Exec executes the deletion query.
func (ludo *LicenseUseDeleteOne) Exec(ctx context.Context) error {
	n, err := ludo.lud.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{licenseuse.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (ludo *LicenseUseDeleteOne) ExecX(ctx context.Context) {
	ludo.lud.ExecX(ctx)
}
