// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/license"
	"github.com/valocode/bubbly/ent/licenseuse"
	"github.com/valocode/bubbly/ent/predicate"
)

// LicenseUseQuery is the builder for querying LicenseUse entities.
type LicenseUseQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.LicenseUse
	// eager-loading edges.
	withLicense *LicenseQuery
	withFKs     bool
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the LicenseUseQuery builder.
func (luq *LicenseUseQuery) Where(ps ...predicate.LicenseUse) *LicenseUseQuery {
	luq.predicates = append(luq.predicates, ps...)
	return luq
}

// Limit adds a limit step to the query.
func (luq *LicenseUseQuery) Limit(limit int) *LicenseUseQuery {
	luq.limit = &limit
	return luq
}

// Offset adds an offset step to the query.
func (luq *LicenseUseQuery) Offset(offset int) *LicenseUseQuery {
	luq.offset = &offset
	return luq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (luq *LicenseUseQuery) Unique(unique bool) *LicenseUseQuery {
	luq.unique = &unique
	return luq
}

// Order adds an order step to the query.
func (luq *LicenseUseQuery) Order(o ...OrderFunc) *LicenseUseQuery {
	luq.order = append(luq.order, o...)
	return luq
}

// QueryLicense chains the current query on the "license" edge.
func (luq *LicenseUseQuery) QueryLicense() *LicenseQuery {
	query := &LicenseQuery{config: luq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := luq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := luq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(licenseuse.Table, licenseuse.FieldID, selector),
			sqlgraph.To(license.Table, license.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, false, licenseuse.LicenseTable, licenseuse.LicenseColumn),
		)
		fromU = sqlgraph.SetNeighbors(luq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first LicenseUse entity from the query.
// Returns a *NotFoundError when no LicenseUse was found.
func (luq *LicenseUseQuery) First(ctx context.Context) (*LicenseUse, error) {
	nodes, err := luq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{licenseuse.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (luq *LicenseUseQuery) FirstX(ctx context.Context) *LicenseUse {
	node, err := luq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first LicenseUse ID from the query.
// Returns a *NotFoundError when no LicenseUse ID was found.
func (luq *LicenseUseQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = luq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{licenseuse.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (luq *LicenseUseQuery) FirstIDX(ctx context.Context) int {
	id, err := luq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single LicenseUse entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when exactly one LicenseUse entity is not found.
// Returns a *NotFoundError when no LicenseUse entities are found.
func (luq *LicenseUseQuery) Only(ctx context.Context) (*LicenseUse, error) {
	nodes, err := luq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{licenseuse.Label}
	default:
		return nil, &NotSingularError{licenseuse.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (luq *LicenseUseQuery) OnlyX(ctx context.Context) *LicenseUse {
	node, err := luq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only LicenseUse ID in the query.
// Returns a *NotSingularError when exactly one LicenseUse ID is not found.
// Returns a *NotFoundError when no entities are found.
func (luq *LicenseUseQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = luq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{licenseuse.Label}
	default:
		err = &NotSingularError{licenseuse.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (luq *LicenseUseQuery) OnlyIDX(ctx context.Context) int {
	id, err := luq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of LicenseUses.
func (luq *LicenseUseQuery) All(ctx context.Context) ([]*LicenseUse, error) {
	if err := luq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return luq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (luq *LicenseUseQuery) AllX(ctx context.Context) []*LicenseUse {
	nodes, err := luq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of LicenseUse IDs.
func (luq *LicenseUseQuery) IDs(ctx context.Context) ([]int, error) {
	var ids []int
	if err := luq.Select(licenseuse.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (luq *LicenseUseQuery) IDsX(ctx context.Context) []int {
	ids, err := luq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (luq *LicenseUseQuery) Count(ctx context.Context) (int, error) {
	if err := luq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return luq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (luq *LicenseUseQuery) CountX(ctx context.Context) int {
	count, err := luq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (luq *LicenseUseQuery) Exist(ctx context.Context) (bool, error) {
	if err := luq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return luq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (luq *LicenseUseQuery) ExistX(ctx context.Context) bool {
	exist, err := luq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the LicenseUseQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (luq *LicenseUseQuery) Clone() *LicenseUseQuery {
	if luq == nil {
		return nil
	}
	return &LicenseUseQuery{
		config:      luq.config,
		limit:       luq.limit,
		offset:      luq.offset,
		order:       append([]OrderFunc{}, luq.order...),
		predicates:  append([]predicate.LicenseUse{}, luq.predicates...),
		withLicense: luq.withLicense.Clone(),
		// clone intermediate query.
		sql:  luq.sql.Clone(),
		path: luq.path,
	}
}

// WithLicense tells the query-builder to eager-load the nodes that are connected to
// the "license" edge. The optional arguments are used to configure the query builder of the edge.
func (luq *LicenseUseQuery) WithLicense(opts ...func(*LicenseQuery)) *LicenseUseQuery {
	query := &LicenseQuery{config: luq.config}
	for _, opt := range opts {
		opt(query)
	}
	luq.withLicense = query
	return luq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
func (luq *LicenseUseQuery) GroupBy(field string, fields ...string) *LicenseUseGroupBy {
	group := &LicenseUseGroupBy{config: luq.config}
	group.fields = append([]string{field}, fields...)
	group.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := luq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return luq.sqlQuery(ctx), nil
	}
	return group
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
func (luq *LicenseUseQuery) Select(fields ...string) *LicenseUseSelect {
	luq.fields = append(luq.fields, fields...)
	return &LicenseUseSelect{LicenseUseQuery: luq}
}

func (luq *LicenseUseQuery) prepareQuery(ctx context.Context) error {
	for _, f := range luq.fields {
		if !licenseuse.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if luq.path != nil {
		prev, err := luq.path(ctx)
		if err != nil {
			return err
		}
		luq.sql = prev
	}
	return nil
}

func (luq *LicenseUseQuery) sqlAll(ctx context.Context) ([]*LicenseUse, error) {
	var (
		nodes       = []*LicenseUse{}
		withFKs     = luq.withFKs
		_spec       = luq.querySpec()
		loadedTypes = [1]bool{
			luq.withLicense != nil,
		}
	)
	if luq.withLicense != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, licenseuse.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		node := &LicenseUse{config: luq.config}
		nodes = append(nodes, node)
		return node.scanValues(columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		if len(nodes) == 0 {
			return fmt.Errorf("ent: Assign called without calling ScanValues")
		}
		node := nodes[len(nodes)-1]
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	if err := sqlgraph.QueryNodes(ctx, luq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}

	if query := luq.withLicense; query != nil {
		ids := make([]int, 0, len(nodes))
		nodeids := make(map[int][]*LicenseUse)
		for i := range nodes {
			if nodes[i].license_use_license == nil {
				continue
			}
			fk := *nodes[i].license_use_license
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(license.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "license_use_license" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.License = n
			}
		}
	}

	return nodes, nil
}

func (luq *LicenseUseQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := luq.querySpec()
	return sqlgraph.CountNodes(ctx, luq.driver, _spec)
}

func (luq *LicenseUseQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := luq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (luq *LicenseUseQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   licenseuse.Table,
			Columns: licenseuse.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: licenseuse.FieldID,
			},
		},
		From:   luq.sql,
		Unique: true,
	}
	if unique := luq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := luq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, licenseuse.FieldID)
		for i := range fields {
			if fields[i] != licenseuse.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := luq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := luq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := luq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := luq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (luq *LicenseUseQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(luq.driver.Dialect())
	t1 := builder.Table(licenseuse.Table)
	columns := luq.fields
	if len(columns) == 0 {
		columns = licenseuse.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if luq.sql != nil {
		selector = luq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	for _, p := range luq.predicates {
		p(selector)
	}
	for _, p := range luq.order {
		p(selector)
	}
	if offset := luq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := luq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// LicenseUseGroupBy is the group-by builder for LicenseUse entities.
type LicenseUseGroupBy struct {
	config
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (lugb *LicenseUseGroupBy) Aggregate(fns ...AggregateFunc) *LicenseUseGroupBy {
	lugb.fns = append(lugb.fns, fns...)
	return lugb
}

// Scan applies the group-by query and scans the result into the given value.
func (lugb *LicenseUseGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := lugb.path(ctx)
	if err != nil {
		return err
	}
	lugb.sql = query
	return lugb.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (lugb *LicenseUseGroupBy) ScanX(ctx context.Context, v interface{}) {
	if err := lugb.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from group-by.
// It is only allowed when executing a group-by query with one field.
func (lugb *LicenseUseGroupBy) Strings(ctx context.Context) ([]string, error) {
	if len(lugb.fields) > 1 {
		return nil, errors.New("ent: LicenseUseGroupBy.Strings is not achievable when grouping more than 1 field")
	}
	var v []string
	if err := lugb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (lugb *LicenseUseGroupBy) StringsX(ctx context.Context) []string {
	v, err := lugb.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (lugb *LicenseUseGroupBy) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = lugb.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{licenseuse.Label}
	default:
		err = fmt.Errorf("ent: LicenseUseGroupBy.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (lugb *LicenseUseGroupBy) StringX(ctx context.Context) string {
	v, err := lugb.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from group-by.
// It is only allowed when executing a group-by query with one field.
func (lugb *LicenseUseGroupBy) Ints(ctx context.Context) ([]int, error) {
	if len(lugb.fields) > 1 {
		return nil, errors.New("ent: LicenseUseGroupBy.Ints is not achievable when grouping more than 1 field")
	}
	var v []int
	if err := lugb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (lugb *LicenseUseGroupBy) IntsX(ctx context.Context) []int {
	v, err := lugb.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (lugb *LicenseUseGroupBy) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = lugb.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{licenseuse.Label}
	default:
		err = fmt.Errorf("ent: LicenseUseGroupBy.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (lugb *LicenseUseGroupBy) IntX(ctx context.Context) int {
	v, err := lugb.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from group-by.
// It is only allowed when executing a group-by query with one field.
func (lugb *LicenseUseGroupBy) Float64s(ctx context.Context) ([]float64, error) {
	if len(lugb.fields) > 1 {
		return nil, errors.New("ent: LicenseUseGroupBy.Float64s is not achievable when grouping more than 1 field")
	}
	var v []float64
	if err := lugb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (lugb *LicenseUseGroupBy) Float64sX(ctx context.Context) []float64 {
	v, err := lugb.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (lugb *LicenseUseGroupBy) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = lugb.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{licenseuse.Label}
	default:
		err = fmt.Errorf("ent: LicenseUseGroupBy.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (lugb *LicenseUseGroupBy) Float64X(ctx context.Context) float64 {
	v, err := lugb.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from group-by.
// It is only allowed when executing a group-by query with one field.
func (lugb *LicenseUseGroupBy) Bools(ctx context.Context) ([]bool, error) {
	if len(lugb.fields) > 1 {
		return nil, errors.New("ent: LicenseUseGroupBy.Bools is not achievable when grouping more than 1 field")
	}
	var v []bool
	if err := lugb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (lugb *LicenseUseGroupBy) BoolsX(ctx context.Context) []bool {
	v, err := lugb.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (lugb *LicenseUseGroupBy) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = lugb.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{licenseuse.Label}
	default:
		err = fmt.Errorf("ent: LicenseUseGroupBy.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (lugb *LicenseUseGroupBy) BoolX(ctx context.Context) bool {
	v, err := lugb.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (lugb *LicenseUseGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range lugb.fields {
		if !licenseuse.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := lugb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := lugb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (lugb *LicenseUseGroupBy) sqlQuery() *sql.Selector {
	selector := lugb.sql.Select()
	aggregation := make([]string, 0, len(lugb.fns))
	for _, fn := range lugb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	// If no columns were selected in a custom aggregation function, the default
	// selection is the fields used for "group-by", and the aggregation functions.
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(lugb.fields)+len(lugb.fns))
		for _, f := range lugb.fields {
			columns = append(columns, selector.C(f))
		}
		for _, c := range aggregation {
			columns = append(columns, c)
		}
		selector.Select(columns...)
	}
	return selector.GroupBy(selector.Columns(lugb.fields...)...)
}

// LicenseUseSelect is the builder for selecting fields of LicenseUse entities.
type LicenseUseSelect struct {
	*LicenseUseQuery
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (lus *LicenseUseSelect) Scan(ctx context.Context, v interface{}) error {
	if err := lus.prepareQuery(ctx); err != nil {
		return err
	}
	lus.sql = lus.LicenseUseQuery.sqlQuery(ctx)
	return lus.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (lus *LicenseUseSelect) ScanX(ctx context.Context, v interface{}) {
	if err := lus.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from a selector. It is only allowed when selecting one field.
func (lus *LicenseUseSelect) Strings(ctx context.Context) ([]string, error) {
	if len(lus.fields) > 1 {
		return nil, errors.New("ent: LicenseUseSelect.Strings is not achievable when selecting more than 1 field")
	}
	var v []string
	if err := lus.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (lus *LicenseUseSelect) StringsX(ctx context.Context) []string {
	v, err := lus.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a selector. It is only allowed when selecting one field.
func (lus *LicenseUseSelect) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = lus.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{licenseuse.Label}
	default:
		err = fmt.Errorf("ent: LicenseUseSelect.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (lus *LicenseUseSelect) StringX(ctx context.Context) string {
	v, err := lus.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from a selector. It is only allowed when selecting one field.
func (lus *LicenseUseSelect) Ints(ctx context.Context) ([]int, error) {
	if len(lus.fields) > 1 {
		return nil, errors.New("ent: LicenseUseSelect.Ints is not achievable when selecting more than 1 field")
	}
	var v []int
	if err := lus.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (lus *LicenseUseSelect) IntsX(ctx context.Context) []int {
	v, err := lus.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a selector. It is only allowed when selecting one field.
func (lus *LicenseUseSelect) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = lus.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{licenseuse.Label}
	default:
		err = fmt.Errorf("ent: LicenseUseSelect.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (lus *LicenseUseSelect) IntX(ctx context.Context) int {
	v, err := lus.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from a selector. It is only allowed when selecting one field.
func (lus *LicenseUseSelect) Float64s(ctx context.Context) ([]float64, error) {
	if len(lus.fields) > 1 {
		return nil, errors.New("ent: LicenseUseSelect.Float64s is not achievable when selecting more than 1 field")
	}
	var v []float64
	if err := lus.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (lus *LicenseUseSelect) Float64sX(ctx context.Context) []float64 {
	v, err := lus.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a selector. It is only allowed when selecting one field.
func (lus *LicenseUseSelect) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = lus.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{licenseuse.Label}
	default:
		err = fmt.Errorf("ent: LicenseUseSelect.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (lus *LicenseUseSelect) Float64X(ctx context.Context) float64 {
	v, err := lus.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from a selector. It is only allowed when selecting one field.
func (lus *LicenseUseSelect) Bools(ctx context.Context) ([]bool, error) {
	if len(lus.fields) > 1 {
		return nil, errors.New("ent: LicenseUseSelect.Bools is not achievable when selecting more than 1 field")
	}
	var v []bool
	if err := lus.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (lus *LicenseUseSelect) BoolsX(ctx context.Context) []bool {
	v, err := lus.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a selector. It is only allowed when selecting one field.
func (lus *LicenseUseSelect) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = lus.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{licenseuse.Label}
	default:
		err = fmt.Errorf("ent: LicenseUseSelect.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (lus *LicenseUseSelect) BoolX(ctx context.Context) bool {
	v, err := lus.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (lus *LicenseUseSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := lus.sql.Query()
	if err := lus.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
