// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/predicate"
	"github.com/valocode/bubbly/ent/release"
	"github.com/valocode/bubbly/ent/releasepolicy"
	"github.com/valocode/bubbly/ent/releasepolicyviolation"
)

// ReleasePolicyViolationQuery is the builder for querying ReleasePolicyViolation entities.
type ReleasePolicyViolationQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.ReleasePolicyViolation
	// eager-loading edges.
	withPolicy  *ReleasePolicyQuery
	withRelease *ReleaseQuery
	withFKs     bool
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the ReleasePolicyViolationQuery builder.
func (rpvq *ReleasePolicyViolationQuery) Where(ps ...predicate.ReleasePolicyViolation) *ReleasePolicyViolationQuery {
	rpvq.predicates = append(rpvq.predicates, ps...)
	return rpvq
}

// Limit adds a limit step to the query.
func (rpvq *ReleasePolicyViolationQuery) Limit(limit int) *ReleasePolicyViolationQuery {
	rpvq.limit = &limit
	return rpvq
}

// Offset adds an offset step to the query.
func (rpvq *ReleasePolicyViolationQuery) Offset(offset int) *ReleasePolicyViolationQuery {
	rpvq.offset = &offset
	return rpvq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (rpvq *ReleasePolicyViolationQuery) Unique(unique bool) *ReleasePolicyViolationQuery {
	rpvq.unique = &unique
	return rpvq
}

// Order adds an order step to the query.
func (rpvq *ReleasePolicyViolationQuery) Order(o ...OrderFunc) *ReleasePolicyViolationQuery {
	rpvq.order = append(rpvq.order, o...)
	return rpvq
}

// QueryPolicy chains the current query on the "policy" edge.
func (rpvq *ReleasePolicyViolationQuery) QueryPolicy() *ReleasePolicyQuery {
	query := &ReleasePolicyQuery{config: rpvq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := rpvq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := rpvq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(releasepolicyviolation.Table, releasepolicyviolation.FieldID, selector),
			sqlgraph.To(releasepolicy.Table, releasepolicy.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, false, releasepolicyviolation.PolicyTable, releasepolicyviolation.PolicyColumn),
		)
		fromU = sqlgraph.SetNeighbors(rpvq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryRelease chains the current query on the "release" edge.
func (rpvq *ReleasePolicyViolationQuery) QueryRelease() *ReleaseQuery {
	query := &ReleaseQuery{config: rpvq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := rpvq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := rpvq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(releasepolicyviolation.Table, releasepolicyviolation.FieldID, selector),
			sqlgraph.To(release.Table, release.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, false, releasepolicyviolation.ReleaseTable, releasepolicyviolation.ReleaseColumn),
		)
		fromU = sqlgraph.SetNeighbors(rpvq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first ReleasePolicyViolation entity from the query.
// Returns a *NotFoundError when no ReleasePolicyViolation was found.
func (rpvq *ReleasePolicyViolationQuery) First(ctx context.Context) (*ReleasePolicyViolation, error) {
	nodes, err := rpvq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{releasepolicyviolation.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (rpvq *ReleasePolicyViolationQuery) FirstX(ctx context.Context) *ReleasePolicyViolation {
	node, err := rpvq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first ReleasePolicyViolation ID from the query.
// Returns a *NotFoundError when no ReleasePolicyViolation ID was found.
func (rpvq *ReleasePolicyViolationQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = rpvq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{releasepolicyviolation.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (rpvq *ReleasePolicyViolationQuery) FirstIDX(ctx context.Context) int {
	id, err := rpvq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single ReleasePolicyViolation entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when exactly one ReleasePolicyViolation entity is not found.
// Returns a *NotFoundError when no ReleasePolicyViolation entities are found.
func (rpvq *ReleasePolicyViolationQuery) Only(ctx context.Context) (*ReleasePolicyViolation, error) {
	nodes, err := rpvq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{releasepolicyviolation.Label}
	default:
		return nil, &NotSingularError{releasepolicyviolation.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (rpvq *ReleasePolicyViolationQuery) OnlyX(ctx context.Context) *ReleasePolicyViolation {
	node, err := rpvq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only ReleasePolicyViolation ID in the query.
// Returns a *NotSingularError when exactly one ReleasePolicyViolation ID is not found.
// Returns a *NotFoundError when no entities are found.
func (rpvq *ReleasePolicyViolationQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = rpvq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{releasepolicyviolation.Label}
	default:
		err = &NotSingularError{releasepolicyviolation.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (rpvq *ReleasePolicyViolationQuery) OnlyIDX(ctx context.Context) int {
	id, err := rpvq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of ReleasePolicyViolations.
func (rpvq *ReleasePolicyViolationQuery) All(ctx context.Context) ([]*ReleasePolicyViolation, error) {
	if err := rpvq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return rpvq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (rpvq *ReleasePolicyViolationQuery) AllX(ctx context.Context) []*ReleasePolicyViolation {
	nodes, err := rpvq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of ReleasePolicyViolation IDs.
func (rpvq *ReleasePolicyViolationQuery) IDs(ctx context.Context) ([]int, error) {
	var ids []int
	if err := rpvq.Select(releasepolicyviolation.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (rpvq *ReleasePolicyViolationQuery) IDsX(ctx context.Context) []int {
	ids, err := rpvq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (rpvq *ReleasePolicyViolationQuery) Count(ctx context.Context) (int, error) {
	if err := rpvq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return rpvq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (rpvq *ReleasePolicyViolationQuery) CountX(ctx context.Context) int {
	count, err := rpvq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (rpvq *ReleasePolicyViolationQuery) Exist(ctx context.Context) (bool, error) {
	if err := rpvq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return rpvq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (rpvq *ReleasePolicyViolationQuery) ExistX(ctx context.Context) bool {
	exist, err := rpvq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the ReleasePolicyViolationQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (rpvq *ReleasePolicyViolationQuery) Clone() *ReleasePolicyViolationQuery {
	if rpvq == nil {
		return nil
	}
	return &ReleasePolicyViolationQuery{
		config:      rpvq.config,
		limit:       rpvq.limit,
		offset:      rpvq.offset,
		order:       append([]OrderFunc{}, rpvq.order...),
		predicates:  append([]predicate.ReleasePolicyViolation{}, rpvq.predicates...),
		withPolicy:  rpvq.withPolicy.Clone(),
		withRelease: rpvq.withRelease.Clone(),
		// clone intermediate query.
		sql:  rpvq.sql.Clone(),
		path: rpvq.path,
	}
}

// WithPolicy tells the query-builder to eager-load the nodes that are connected to
// the "policy" edge. The optional arguments are used to configure the query builder of the edge.
func (rpvq *ReleasePolicyViolationQuery) WithPolicy(opts ...func(*ReleasePolicyQuery)) *ReleasePolicyViolationQuery {
	query := &ReleasePolicyQuery{config: rpvq.config}
	for _, opt := range opts {
		opt(query)
	}
	rpvq.withPolicy = query
	return rpvq
}

// WithRelease tells the query-builder to eager-load the nodes that are connected to
// the "release" edge. The optional arguments are used to configure the query builder of the edge.
func (rpvq *ReleasePolicyViolationQuery) WithRelease(opts ...func(*ReleaseQuery)) *ReleasePolicyViolationQuery {
	query := &ReleaseQuery{config: rpvq.config}
	for _, opt := range opts {
		opt(query)
	}
	rpvq.withRelease = query
	return rpvq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		Message string `json:"message,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.ReleasePolicyViolation.Query().
//		GroupBy(releasepolicyviolation.FieldMessage).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
//
func (rpvq *ReleasePolicyViolationQuery) GroupBy(field string, fields ...string) *ReleasePolicyViolationGroupBy {
	group := &ReleasePolicyViolationGroupBy{config: rpvq.config}
	group.fields = append([]string{field}, fields...)
	group.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := rpvq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return rpvq.sqlQuery(ctx), nil
	}
	return group
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		Message string `json:"message,omitempty"`
//	}
//
//	client.ReleasePolicyViolation.Query().
//		Select(releasepolicyviolation.FieldMessage).
//		Scan(ctx, &v)
//
func (rpvq *ReleasePolicyViolationQuery) Select(fields ...string) *ReleasePolicyViolationSelect {
	rpvq.fields = append(rpvq.fields, fields...)
	return &ReleasePolicyViolationSelect{ReleasePolicyViolationQuery: rpvq}
}

func (rpvq *ReleasePolicyViolationQuery) prepareQuery(ctx context.Context) error {
	for _, f := range rpvq.fields {
		if !releasepolicyviolation.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if rpvq.path != nil {
		prev, err := rpvq.path(ctx)
		if err != nil {
			return err
		}
		rpvq.sql = prev
	}
	return nil
}

func (rpvq *ReleasePolicyViolationQuery) sqlAll(ctx context.Context) ([]*ReleasePolicyViolation, error) {
	var (
		nodes       = []*ReleasePolicyViolation{}
		withFKs     = rpvq.withFKs
		_spec       = rpvq.querySpec()
		loadedTypes = [2]bool{
			rpvq.withPolicy != nil,
			rpvq.withRelease != nil,
		}
	)
	if rpvq.withPolicy != nil || rpvq.withRelease != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, releasepolicyviolation.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		node := &ReleasePolicyViolation{config: rpvq.config}
		nodes = append(nodes, node)
		return node.scanValues(columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		if len(nodes) == 0 {
			return fmt.Errorf("ent: Assign called without calling ScanValues")
		}
		node := nodes[len(nodes)-1]
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	if err := sqlgraph.QueryNodes(ctx, rpvq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}

	if query := rpvq.withPolicy; query != nil {
		ids := make([]int, 0, len(nodes))
		nodeids := make(map[int][]*ReleasePolicyViolation)
		for i := range nodes {
			if nodes[i].release_policy_violation_policy == nil {
				continue
			}
			fk := *nodes[i].release_policy_violation_policy
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(releasepolicy.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "release_policy_violation_policy" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.Policy = n
			}
		}
	}

	if query := rpvq.withRelease; query != nil {
		ids := make([]int, 0, len(nodes))
		nodeids := make(map[int][]*ReleasePolicyViolation)
		for i := range nodes {
			if nodes[i].release_policy_violation_release == nil {
				continue
			}
			fk := *nodes[i].release_policy_violation_release
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(release.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "release_policy_violation_release" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.Release = n
			}
		}
	}

	return nodes, nil
}

func (rpvq *ReleasePolicyViolationQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := rpvq.querySpec()
	return sqlgraph.CountNodes(ctx, rpvq.driver, _spec)
}

func (rpvq *ReleasePolicyViolationQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := rpvq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (rpvq *ReleasePolicyViolationQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   releasepolicyviolation.Table,
			Columns: releasepolicyviolation.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: releasepolicyviolation.FieldID,
			},
		},
		From:   rpvq.sql,
		Unique: true,
	}
	if unique := rpvq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := rpvq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, releasepolicyviolation.FieldID)
		for i := range fields {
			if fields[i] != releasepolicyviolation.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := rpvq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := rpvq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := rpvq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := rpvq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (rpvq *ReleasePolicyViolationQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(rpvq.driver.Dialect())
	t1 := builder.Table(releasepolicyviolation.Table)
	columns := rpvq.fields
	if len(columns) == 0 {
		columns = releasepolicyviolation.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if rpvq.sql != nil {
		selector = rpvq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	for _, p := range rpvq.predicates {
		p(selector)
	}
	for _, p := range rpvq.order {
		p(selector)
	}
	if offset := rpvq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := rpvq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// ReleasePolicyViolationGroupBy is the group-by builder for ReleasePolicyViolation entities.
type ReleasePolicyViolationGroupBy struct {
	config
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (rpvgb *ReleasePolicyViolationGroupBy) Aggregate(fns ...AggregateFunc) *ReleasePolicyViolationGroupBy {
	rpvgb.fns = append(rpvgb.fns, fns...)
	return rpvgb
}

// Scan applies the group-by query and scans the result into the given value.
func (rpvgb *ReleasePolicyViolationGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := rpvgb.path(ctx)
	if err != nil {
		return err
	}
	rpvgb.sql = query
	return rpvgb.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (rpvgb *ReleasePolicyViolationGroupBy) ScanX(ctx context.Context, v interface{}) {
	if err := rpvgb.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from group-by.
// It is only allowed when executing a group-by query with one field.
func (rpvgb *ReleasePolicyViolationGroupBy) Strings(ctx context.Context) ([]string, error) {
	if len(rpvgb.fields) > 1 {
		return nil, errors.New("ent: ReleasePolicyViolationGroupBy.Strings is not achievable when grouping more than 1 field")
	}
	var v []string
	if err := rpvgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (rpvgb *ReleasePolicyViolationGroupBy) StringsX(ctx context.Context) []string {
	v, err := rpvgb.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (rpvgb *ReleasePolicyViolationGroupBy) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = rpvgb.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releasepolicyviolation.Label}
	default:
		err = fmt.Errorf("ent: ReleasePolicyViolationGroupBy.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (rpvgb *ReleasePolicyViolationGroupBy) StringX(ctx context.Context) string {
	v, err := rpvgb.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from group-by.
// It is only allowed when executing a group-by query with one field.
func (rpvgb *ReleasePolicyViolationGroupBy) Ints(ctx context.Context) ([]int, error) {
	if len(rpvgb.fields) > 1 {
		return nil, errors.New("ent: ReleasePolicyViolationGroupBy.Ints is not achievable when grouping more than 1 field")
	}
	var v []int
	if err := rpvgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (rpvgb *ReleasePolicyViolationGroupBy) IntsX(ctx context.Context) []int {
	v, err := rpvgb.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (rpvgb *ReleasePolicyViolationGroupBy) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = rpvgb.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releasepolicyviolation.Label}
	default:
		err = fmt.Errorf("ent: ReleasePolicyViolationGroupBy.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (rpvgb *ReleasePolicyViolationGroupBy) IntX(ctx context.Context) int {
	v, err := rpvgb.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from group-by.
// It is only allowed when executing a group-by query with one field.
func (rpvgb *ReleasePolicyViolationGroupBy) Float64s(ctx context.Context) ([]float64, error) {
	if len(rpvgb.fields) > 1 {
		return nil, errors.New("ent: ReleasePolicyViolationGroupBy.Float64s is not achievable when grouping more than 1 field")
	}
	var v []float64
	if err := rpvgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (rpvgb *ReleasePolicyViolationGroupBy) Float64sX(ctx context.Context) []float64 {
	v, err := rpvgb.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (rpvgb *ReleasePolicyViolationGroupBy) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = rpvgb.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releasepolicyviolation.Label}
	default:
		err = fmt.Errorf("ent: ReleasePolicyViolationGroupBy.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (rpvgb *ReleasePolicyViolationGroupBy) Float64X(ctx context.Context) float64 {
	v, err := rpvgb.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from group-by.
// It is only allowed when executing a group-by query with one field.
func (rpvgb *ReleasePolicyViolationGroupBy) Bools(ctx context.Context) ([]bool, error) {
	if len(rpvgb.fields) > 1 {
		return nil, errors.New("ent: ReleasePolicyViolationGroupBy.Bools is not achievable when grouping more than 1 field")
	}
	var v []bool
	if err := rpvgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (rpvgb *ReleasePolicyViolationGroupBy) BoolsX(ctx context.Context) []bool {
	v, err := rpvgb.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (rpvgb *ReleasePolicyViolationGroupBy) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = rpvgb.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releasepolicyviolation.Label}
	default:
		err = fmt.Errorf("ent: ReleasePolicyViolationGroupBy.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (rpvgb *ReleasePolicyViolationGroupBy) BoolX(ctx context.Context) bool {
	v, err := rpvgb.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (rpvgb *ReleasePolicyViolationGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range rpvgb.fields {
		if !releasepolicyviolation.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := rpvgb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := rpvgb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (rpvgb *ReleasePolicyViolationGroupBy) sqlQuery() *sql.Selector {
	selector := rpvgb.sql.Select()
	aggregation := make([]string, 0, len(rpvgb.fns))
	for _, fn := range rpvgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	// If no columns were selected in a custom aggregation function, the default
	// selection is the fields used for "group-by", and the aggregation functions.
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(rpvgb.fields)+len(rpvgb.fns))
		for _, f := range rpvgb.fields {
			columns = append(columns, selector.C(f))
		}
		for _, c := range aggregation {
			columns = append(columns, c)
		}
		selector.Select(columns...)
	}
	return selector.GroupBy(selector.Columns(rpvgb.fields...)...)
}

// ReleasePolicyViolationSelect is the builder for selecting fields of ReleasePolicyViolation entities.
type ReleasePolicyViolationSelect struct {
	*ReleasePolicyViolationQuery
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (rpvs *ReleasePolicyViolationSelect) Scan(ctx context.Context, v interface{}) error {
	if err := rpvs.prepareQuery(ctx); err != nil {
		return err
	}
	rpvs.sql = rpvs.ReleasePolicyViolationQuery.sqlQuery(ctx)
	return rpvs.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (rpvs *ReleasePolicyViolationSelect) ScanX(ctx context.Context, v interface{}) {
	if err := rpvs.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from a selector. It is only allowed when selecting one field.
func (rpvs *ReleasePolicyViolationSelect) Strings(ctx context.Context) ([]string, error) {
	if len(rpvs.fields) > 1 {
		return nil, errors.New("ent: ReleasePolicyViolationSelect.Strings is not achievable when selecting more than 1 field")
	}
	var v []string
	if err := rpvs.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (rpvs *ReleasePolicyViolationSelect) StringsX(ctx context.Context) []string {
	v, err := rpvs.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a selector. It is only allowed when selecting one field.
func (rpvs *ReleasePolicyViolationSelect) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = rpvs.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releasepolicyviolation.Label}
	default:
		err = fmt.Errorf("ent: ReleasePolicyViolationSelect.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (rpvs *ReleasePolicyViolationSelect) StringX(ctx context.Context) string {
	v, err := rpvs.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from a selector. It is only allowed when selecting one field.
func (rpvs *ReleasePolicyViolationSelect) Ints(ctx context.Context) ([]int, error) {
	if len(rpvs.fields) > 1 {
		return nil, errors.New("ent: ReleasePolicyViolationSelect.Ints is not achievable when selecting more than 1 field")
	}
	var v []int
	if err := rpvs.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (rpvs *ReleasePolicyViolationSelect) IntsX(ctx context.Context) []int {
	v, err := rpvs.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a selector. It is only allowed when selecting one field.
func (rpvs *ReleasePolicyViolationSelect) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = rpvs.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releasepolicyviolation.Label}
	default:
		err = fmt.Errorf("ent: ReleasePolicyViolationSelect.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (rpvs *ReleasePolicyViolationSelect) IntX(ctx context.Context) int {
	v, err := rpvs.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from a selector. It is only allowed when selecting one field.
func (rpvs *ReleasePolicyViolationSelect) Float64s(ctx context.Context) ([]float64, error) {
	if len(rpvs.fields) > 1 {
		return nil, errors.New("ent: ReleasePolicyViolationSelect.Float64s is not achievable when selecting more than 1 field")
	}
	var v []float64
	if err := rpvs.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (rpvs *ReleasePolicyViolationSelect) Float64sX(ctx context.Context) []float64 {
	v, err := rpvs.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a selector. It is only allowed when selecting one field.
func (rpvs *ReleasePolicyViolationSelect) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = rpvs.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releasepolicyviolation.Label}
	default:
		err = fmt.Errorf("ent: ReleasePolicyViolationSelect.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (rpvs *ReleasePolicyViolationSelect) Float64X(ctx context.Context) float64 {
	v, err := rpvs.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from a selector. It is only allowed when selecting one field.
func (rpvs *ReleasePolicyViolationSelect) Bools(ctx context.Context) ([]bool, error) {
	if len(rpvs.fields) > 1 {
		return nil, errors.New("ent: ReleasePolicyViolationSelect.Bools is not achievable when selecting more than 1 field")
	}
	var v []bool
	if err := rpvs.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (rpvs *ReleasePolicyViolationSelect) BoolsX(ctx context.Context) []bool {
	v, err := rpvs.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a selector. It is only allowed when selecting one field.
func (rpvs *ReleasePolicyViolationSelect) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = rpvs.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releasepolicyviolation.Label}
	default:
		err = fmt.Errorf("ent: ReleasePolicyViolationSelect.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (rpvs *ReleasePolicyViolationSelect) BoolX(ctx context.Context) bool {
	v, err := rpvs.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (rpvs *ReleasePolicyViolationSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := rpvs.sql.Query()
	if err := rpvs.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
