// Code generated by entc, DO NOT EDIT.

package repo

const (
	// Label holds the string label denoting the repo type in the database.
	Label = "repo"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldName holds the string denoting the name field in the database.
	FieldName = "name"
	// FieldDefaultBranch holds the string denoting the default_branch field in the database.
	FieldDefaultBranch = "default_branch"
	// EdgeOwner holds the string denoting the owner edge name in mutations.
	EdgeOwner = "owner"
	// EdgeProject holds the string denoting the project edge name in mutations.
	EdgeProject = "project"
	// EdgeHead holds the string denoting the head edge name in mutations.
	EdgeHead = "head"
	// EdgeCommits holds the string denoting the commits edge name in mutations.
	EdgeCommits = "commits"
	// EdgeVulnerabilityReviews holds the string denoting the vulnerability_reviews edge name in mutations.
	EdgeVulnerabilityReviews = "vulnerability_reviews"
	// EdgePolicies holds the string denoting the policies edge name in mutations.
	EdgePolicies = "policies"
	// Table holds the table name of the repo in the database.
	Table = "repo"
	// OwnerTable is the table that holds the owner relation/edge.
	OwnerTable = "repo"
	// OwnerInverseTable is the table name for the Organization entity.
	// It exists in this package in order to avoid circular dependency with the "organization" package.
	OwnerInverseTable = "organization"
	// OwnerColumn is the table column denoting the owner relation/edge.
	OwnerColumn = "repo_owner"
	// ProjectTable is the table that holds the project relation/edge.
	ProjectTable = "repo"
	// ProjectInverseTable is the table name for the Project entity.
	// It exists in this package in order to avoid circular dependency with the "project" package.
	ProjectInverseTable = "project"
	// ProjectColumn is the table column denoting the project relation/edge.
	ProjectColumn = "repo_project"
	// HeadTable is the table that holds the head relation/edge.
	HeadTable = "release"
	// HeadInverseTable is the table name for the Release entity.
	// It exists in this package in order to avoid circular dependency with the "release" package.
	HeadInverseTable = "release"
	// HeadColumn is the table column denoting the head relation/edge.
	HeadColumn = "repo_head"
	// CommitsTable is the table that holds the commits relation/edge.
	CommitsTable = "commit"
	// CommitsInverseTable is the table name for the GitCommit entity.
	// It exists in this package in order to avoid circular dependency with the "gitcommit" package.
	CommitsInverseTable = "commit"
	// CommitsColumn is the table column denoting the commits relation/edge.
	CommitsColumn = "git_commit_repo"
	// VulnerabilityReviewsTable is the table that holds the vulnerability_reviews relation/edge. The primary key declared below.
	VulnerabilityReviewsTable = "vulnerability_review_repos"
	// VulnerabilityReviewsInverseTable is the table name for the VulnerabilityReview entity.
	// It exists in this package in order to avoid circular dependency with the "vulnerabilityreview" package.
	VulnerabilityReviewsInverseTable = "vulnerability_review"
	// PoliciesTable is the table that holds the policies relation/edge. The primary key declared below.
	PoliciesTable = "release_policy_repos"
	// PoliciesInverseTable is the table name for the ReleasePolicy entity.
	// It exists in this package in order to avoid circular dependency with the "releasepolicy" package.
	PoliciesInverseTable = "release_policy"
)

// Columns holds all SQL columns for repo fields.
var Columns = []string{
	FieldID,
	FieldName,
	FieldDefaultBranch,
}

// ForeignKeys holds the SQL foreign-keys that are owned by the "repo"
// table and are not defined as standalone fields in the schema.
var ForeignKeys = []string{
	"repo_owner",
	"repo_project",
}

var (
	// VulnerabilityReviewsPrimaryKey and VulnerabilityReviewsColumn2 are the table columns denoting the
	// primary key for the vulnerability_reviews relation (M2M).
	VulnerabilityReviewsPrimaryKey = []string{"vulnerability_review_id", "repo_id"}
	// PoliciesPrimaryKey and PoliciesColumn2 are the table columns denoting the
	// primary key for the policies relation (M2M).
	PoliciesPrimaryKey = []string{"release_policy_id", "repo_id"}
)

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	for i := range ForeignKeys {
		if column == ForeignKeys[i] {
			return true
		}
	}
	return false
}

var (
	// NameValidator is a validator for the "name" field. It is called by the builders before save.
	NameValidator func(string) error
	// DefaultDefaultBranch holds the default value on creation for the "default_branch" field.
	DefaultDefaultBranch string
	// DefaultBranchValidator is a validator for the "default_branch" field. It is called by the builders before save.
	DefaultBranchValidator func(string) error
)
