package schema

import (
	"entgo.io/ent"
	"entgo.io/ent/dialect/entsql"
	"entgo.io/ent/schema"
	"entgo.io/ent/schema/edge"
)

type ReleaseVulnerability struct {
	ent.Schema
}

func (ReleaseVulnerability) Annotations() []schema.Annotation {
	return []schema.Annotation{
		entsql.Annotation{Table: "release_vulnerability"},
	}
}

func (ReleaseVulnerability) Fields() []ent.Field {
	return []ent.Field{}
}

func (ReleaseVulnerability) Edges() []ent.Edge {
	return []ent.Edge{
		// Edge to the actual vulnerability for this
		edge.To("vulnerability", Vulnerability.Type).Unique().Required(),
		edge.To("component", ReleaseComponent.Type).Unique(),
		edge.To("release", Release.Type).Unique().Required(),
		edge.To("reviews", VulnerabilityReview.Type),
		// Scan is optional and only used if the vulnerability was identified by
		// a tool integrated with an adapter
		edge.To("scan", CodeScan.Type).Unique(),
	}
}
