// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/vulnerability"

	"github.com/valocode/bubbly/ent/component"
	"github.com/valocode/bubbly/ent/organization"
	"github.com/valocode/bubbly/ent/releasevulnerability"
	schema "github.com/valocode/bubbly/ent/schema/types"
	"github.com/valocode/bubbly/ent/vulnerabilityreview"
)

// VulnerabilityCreate is the builder for creating a Vulnerability entity.
type VulnerabilityCreate struct {
	config
	mutation *VulnerabilityMutation
	hooks    []Hook
}

// SetVid sets the "vid" field.
func (vc *VulnerabilityCreate) SetVid(s string) *VulnerabilityCreate {
	vc.mutation.SetVid(s)
	return vc
}

// SetSummary sets the "summary" field.
func (vc *VulnerabilityCreate) SetSummary(s string) *VulnerabilityCreate {
	vc.mutation.SetSummary(s)
	return vc
}

// SetNillableSummary sets the "summary" field if the given value is not nil.
func (vc *VulnerabilityCreate) SetNillableSummary(s *string) *VulnerabilityCreate {
	if s != nil {
		vc.SetSummary(*s)
	}
	return vc
}

// SetDescription sets the "description" field.
func (vc *VulnerabilityCreate) SetDescription(s string) *VulnerabilityCreate {
	vc.mutation.SetDescription(s)
	return vc
}

// SetNillableDescription sets the "description" field if the given value is not nil.
func (vc *VulnerabilityCreate) SetNillableDescription(s *string) *VulnerabilityCreate {
	if s != nil {
		vc.SetDescription(*s)
	}
	return vc
}

// SetSeverityScore sets the "severity_score" field.
func (vc *VulnerabilityCreate) SetSeverityScore(f float64) *VulnerabilityCreate {
	vc.mutation.SetSeverityScore(f)
	return vc
}

// SetNillableSeverityScore sets the "severity_score" field if the given value is not nil.
func (vc *VulnerabilityCreate) SetNillableSeverityScore(f *float64) *VulnerabilityCreate {
	if f != nil {
		vc.SetSeverityScore(*f)
	}
	return vc
}

// SetSeverity sets the "severity" field.
func (vc *VulnerabilityCreate) SetSeverity(v vulnerability.Severity) *VulnerabilityCreate {
	vc.mutation.SetSeverity(v)
	return vc
}

// SetNillableSeverity sets the "severity" field if the given value is not nil.
func (vc *VulnerabilityCreate) SetNillableSeverity(v *vulnerability.Severity) *VulnerabilityCreate {
	if v != nil {
		vc.SetSeverity(*v)
	}
	return vc
}

// SetPublished sets the "published" field.
func (vc *VulnerabilityCreate) SetPublished(t time.Time) *VulnerabilityCreate {
	vc.mutation.SetPublished(t)
	return vc
}

// SetNillablePublished sets the "published" field if the given value is not nil.
func (vc *VulnerabilityCreate) SetNillablePublished(t *time.Time) *VulnerabilityCreate {
	if t != nil {
		vc.SetPublished(*t)
	}
	return vc
}

// SetModified sets the "modified" field.
func (vc *VulnerabilityCreate) SetModified(t time.Time) *VulnerabilityCreate {
	vc.mutation.SetModified(t)
	return vc
}

// SetNillableModified sets the "modified" field if the given value is not nil.
func (vc *VulnerabilityCreate) SetNillableModified(t *time.Time) *VulnerabilityCreate {
	if t != nil {
		vc.SetModified(*t)
	}
	return vc
}

// SetMetadata sets the "metadata" field.
func (vc *VulnerabilityCreate) SetMetadata(s schema.Metadata) *VulnerabilityCreate {
	vc.mutation.SetMetadata(s)
	return vc
}

// SetOwnerID sets the "owner" edge to the Organization entity by ID.
func (vc *VulnerabilityCreate) SetOwnerID(id int) *VulnerabilityCreate {
	vc.mutation.SetOwnerID(id)
	return vc
}

// SetOwner sets the "owner" edge to the Organization entity.
func (vc *VulnerabilityCreate) SetOwner(o *Organization) *VulnerabilityCreate {
	return vc.SetOwnerID(o.ID)
}

// AddComponentIDs adds the "components" edge to the Component entity by IDs.
func (vc *VulnerabilityCreate) AddComponentIDs(ids ...int) *VulnerabilityCreate {
	vc.mutation.AddComponentIDs(ids...)
	return vc
}

// AddComponents adds the "components" edges to the Component entity.
func (vc *VulnerabilityCreate) AddComponents(c ...*Component) *VulnerabilityCreate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return vc.AddComponentIDs(ids...)
}

// AddReviewIDs adds the "reviews" edge to the VulnerabilityReview entity by IDs.
func (vc *VulnerabilityCreate) AddReviewIDs(ids ...int) *VulnerabilityCreate {
	vc.mutation.AddReviewIDs(ids...)
	return vc
}

// AddReviews adds the "reviews" edges to the VulnerabilityReview entity.
func (vc *VulnerabilityCreate) AddReviews(v ...*VulnerabilityReview) *VulnerabilityCreate {
	ids := make([]int, len(v))
	for i := range v {
		ids[i] = v[i].ID
	}
	return vc.AddReviewIDs(ids...)
}

// AddInstanceIDs adds the "instances" edge to the ReleaseVulnerability entity by IDs.
func (vc *VulnerabilityCreate) AddInstanceIDs(ids ...int) *VulnerabilityCreate {
	vc.mutation.AddInstanceIDs(ids...)
	return vc
}

// AddInstances adds the "instances" edges to the ReleaseVulnerability entity.
func (vc *VulnerabilityCreate) AddInstances(r ...*ReleaseVulnerability) *VulnerabilityCreate {
	ids := make([]int, len(r))
	for i := range r {
		ids[i] = r[i].ID
	}
	return vc.AddInstanceIDs(ids...)
}

// Mutation returns the VulnerabilityMutation object of the builder.
func (vc *VulnerabilityCreate) Mutation() *VulnerabilityMutation {
	return vc.mutation
}

// Save creates the Vulnerability in the database.
func (vc *VulnerabilityCreate) Save(ctx context.Context) (*Vulnerability, error) {
	var (
		err  error
		node *Vulnerability
	)
	if err := vc.defaults(); err != nil {
		return nil, err
	}
	if len(vc.hooks) == 0 {
		if err = vc.check(); err != nil {
			return nil, err
		}
		node, err = vc.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*VulnerabilityMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = vc.check(); err != nil {
				return nil, err
			}
			vc.mutation = mutation
			if node, err = vc.sqlSave(ctx); err != nil {
				return nil, err
			}
			mutation.id = &node.ID
			mutation.done = true
			return node, err
		})
		for i := len(vc.hooks) - 1; i >= 0; i-- {
			if vc.hooks[i] == nil {
				return nil, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = vc.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, vc.mutation); err != nil {
			return nil, err
		}
	}
	return node, err
}

// SaveX calls Save and panics if Save returns an error.
func (vc *VulnerabilityCreate) SaveX(ctx context.Context) *Vulnerability {
	v, err := vc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (vc *VulnerabilityCreate) Exec(ctx context.Context) error {
	_, err := vc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (vc *VulnerabilityCreate) ExecX(ctx context.Context) {
	if err := vc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (vc *VulnerabilityCreate) defaults() error {
	if _, ok := vc.mutation.SeverityScore(); !ok {
		v := vulnerability.DefaultSeverityScore
		vc.mutation.SetSeverityScore(v)
	}
	if _, ok := vc.mutation.Severity(); !ok {
		v := vulnerability.DefaultSeverity
		vc.mutation.SetSeverity(v)
	}
	return nil
}

// check runs all checks and user-defined validators on the builder.
func (vc *VulnerabilityCreate) check() error {
	if _, ok := vc.mutation.Vid(); !ok {
		return &ValidationError{Name: "vid", err: errors.New(`ent: missing required field "vid"`)}
	}
	if v, ok := vc.mutation.Vid(); ok {
		if err := vulnerability.VidValidator(v); err != nil {
			return &ValidationError{Name: "vid", err: fmt.Errorf(`ent: validator failed for field "vid": %w`, err)}
		}
	}
	if _, ok := vc.mutation.SeverityScore(); !ok {
		return &ValidationError{Name: "severity_score", err: errors.New(`ent: missing required field "severity_score"`)}
	}
	if _, ok := vc.mutation.Severity(); !ok {
		return &ValidationError{Name: "severity", err: errors.New(`ent: missing required field "severity"`)}
	}
	if v, ok := vc.mutation.Severity(); ok {
		if err := vulnerability.SeverityValidator(v); err != nil {
			return &ValidationError{Name: "severity", err: fmt.Errorf(`ent: validator failed for field "severity": %w`, err)}
		}
	}
	if _, ok := vc.mutation.OwnerID(); !ok {
		return &ValidationError{Name: "owner", err: errors.New("ent: missing required edge \"owner\"")}
	}
	return nil
}

func (vc *VulnerabilityCreate) sqlSave(ctx context.Context) (*Vulnerability, error) {
	_node, _spec := vc.createSpec()
	if err := sqlgraph.CreateNode(ctx, vc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{err.Error(), err}
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	return _node, nil
}

func (vc *VulnerabilityCreate) createSpec() (*Vulnerability, *sqlgraph.CreateSpec) {
	var (
		_node = &Vulnerability{config: vc.config}
		_spec = &sqlgraph.CreateSpec{
			Table: vulnerability.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: vulnerability.FieldID,
			},
		}
	)
	if value, ok := vc.mutation.Vid(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: vulnerability.FieldVid,
		})
		_node.Vid = value
	}
	if value, ok := vc.mutation.Summary(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: vulnerability.FieldSummary,
		})
		_node.Summary = value
	}
	if value, ok := vc.mutation.Description(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: vulnerability.FieldDescription,
		})
		_node.Description = value
	}
	if value, ok := vc.mutation.SeverityScore(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: vulnerability.FieldSeverityScore,
		})
		_node.SeverityScore = value
	}
	if value, ok := vc.mutation.Severity(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeEnum,
			Value:  value,
			Column: vulnerability.FieldSeverity,
		})
		_node.Severity = value
	}
	if value, ok := vc.mutation.Published(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: vulnerability.FieldPublished,
		})
		_node.Published = value
	}
	if value, ok := vc.mutation.Modified(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: vulnerability.FieldModified,
		})
		_node.Modified = value
	}
	if value, ok := vc.mutation.Metadata(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeJSON,
			Value:  value,
			Column: vulnerability.FieldMetadata,
		})
		_node.Metadata = value
	}
	if nodes := vc.mutation.OwnerIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: false,
			Table:   vulnerability.OwnerTable,
			Columns: []string{vulnerability.OwnerColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeInt,
					Column: organization.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.vulnerability_owner = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := vc.mutation.ComponentsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   vulnerability.ComponentsTable,
			Columns: vulnerability.ComponentsPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeInt,
					Column: component.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := vc.mutation.ReviewsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: true,
			Table:   vulnerability.ReviewsTable,
			Columns: []string{vulnerability.ReviewsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeInt,
					Column: vulnerabilityreview.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := vc.mutation.InstancesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: true,
			Table:   vulnerability.InstancesTable,
			Columns: []string{vulnerability.InstancesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeInt,
					Column: releasevulnerability.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// VulnerabilityCreateBulk is the builder for creating many Vulnerability entities in bulk.
type VulnerabilityCreateBulk struct {
	config
	builders []*VulnerabilityCreate
}

// Save creates the Vulnerability entities in the database.
func (vcb *VulnerabilityCreateBulk) Save(ctx context.Context) ([]*Vulnerability, error) {
	specs := make([]*sqlgraph.CreateSpec, len(vcb.builders))
	nodes := make([]*Vulnerability, len(vcb.builders))
	mutators := make([]Mutator, len(vcb.builders))
	for i := range vcb.builders {
		func(i int, root context.Context) {
			builder := vcb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*VulnerabilityMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				nodes[i], specs[i] = builder.createSpec()
				var err error
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, vcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, vcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{err.Error(), err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				mutation.done = true
				if specs[i].ID.Value != nil {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, vcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (vcb *VulnerabilityCreateBulk) SaveX(ctx context.Context) []*Vulnerability {
	v, err := vcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (vcb *VulnerabilityCreateBulk) Exec(ctx context.Context) error {
	_, err := vcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (vcb *VulnerabilityCreateBulk) ExecX(ctx context.Context) {
	if err := vcb.Exec(ctx); err != nil {
		panic(err)
	}
}
